/**
 * @file event_system.cpp
 * @brief EventSystem component implementation
 * @author Mahmoud Elmohtady
 * @company Nabd solutions - ASF
 * @copyright Copyright (c) 2025
 */
#include "logger.hpp"
#include "event_system.hpp"

static const char* TAG = "event system";

EventSystem::EventSystem()
    : m_isInitialized(false)
{
}

EventSystem::~EventSystem()
{
    deinitialize();
}

bool EventSystem::initialize()
{
    // TODO: Implement initialization
    m_isInitialized = true;
    ASF_LOGI(TAG, 4200, asf::logger::Criticality::LOW, "event system initialized successfully");
    return true;
}

bool EventSystem::deinitialize()
{
    if (!m_isInitialized)
    {
        return false;
    }

    // TODO: Implement deinitialization
    m_isInitialized = false;
    return true;
}

bool EventSystem::isInitialized() const
{
    return m_isInitialized;
}
